Bug 212045 - Review Request: eclipse-emf - Eclipse Modeling Framework
Review Request: eclipse-emf - Eclipse Modeling Framework
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Thomas Fitzsimmons
Fedora Package Reviews List
:
Depends On:
Blocks: FE-ACCEPT
  Show dependency treegraph
 
Reported: 2006-10-24 15:18 EDT by Andrew Overholt
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version: 2.2.1-9.fc6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-10-30 13:41:43 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Andrew Overholt 2006-10-24 15:18:31 EDT
Spec URL: http://overholt.ca/eclipse/eclipse-emf.spec
SRPM URL: http://overholt.ca/eclipse/eclipse-emf-2.2.1-1.src.rpm
Description: EMF is a modeling framework and code generation facility for building tools and other applications based on a structured data model.
Comment 1 Thomas Fitzsimmons 2006-10-24 16:42:20 EDT
I'll review this.
Comment 2 Thomas Fitzsimmons 2006-10-25 11:51:57 EDT
Some comments about the spec file:

The fedora and redhat macros don't seem to be needed.  Can't you just define
gcj_support to 0 or 1?  Similarly, the majmin macro is only used once, so it is
not needed.

The fetching instructions are fairly involved.  Does upstream not release
tarballs?  How do you know that build_200609210005 corresponds to the 2.2.1
sources?  If fetching from CVS is the only option (as I've heard it is for some
Eclipse projects) then why don't you include this fetching script as a source in
the SRPM?  That way it can be committed to FE CVS and used to create tarballs of
subsequent "releases".  (I tried to run the commented fetch script but the patch
sections failed.  Somehow the tabs in the original patch have been converted to
spaces in the comment, so patch can't locate the correct context.  Also, try the
'patch -p0 << "_EOF_"' form instead of manually escaping each $ character.)

Should the bootclasspath munging be done as a patch?  Or maybe it can be
eliminated altogether: if you specify bootclasspath, you need to make sure that
libgcj.jar or rt.jar is still on the resulting bootclasspath.  That is one
reason why you'd see "java.lang.Object cannot be found".

One other thing: I think license.html should be marked %doc.

I'll post the MUST/SHOULD checklist as a separate comment.
Comment 3 Andrew Overholt 2006-10-25 14:32:52 EDT
(In reply to comment #2)
> The fedora and redhat macros don't seem to be needed.  Can't you just define
> gcj_support to 0 or 1?  Similarly, the majmin macro is only used once, so it is
> not needed.

Fixed.

> The fetching instructions are fairly involved.  Does upstream not release
> tarballs?

No.

> How do you know that build_200609210005 corresponds to the 2.2.1
> sources?

EMF's download page links to their map file:

http://download.eclipse.org/tools/emf/downloads/drops/2.2.1/R200609210005/directory.txt

This shows what CVS tag corresponds to this release.  I'll note this in the
specfile.

> If fetching from CVS is the only option (as I've heard it is for some
> Eclipse projects) then why don't you include this fetching script as a source in
> the SRPM?

Yeah, all (I could be wrong but I'm almost positive it's all) eclipse.org
project don't release source tarballs ... at least not ones we can use.  The
Eclipse SDK is the notable exception here as they release their buildable source
drops, of course.

> Should the bootclasspath munging be done as a patch?

It's doing it in generated files so no.

> One other thing: I think license.html should be marked %doc.

Done.

> I'll post the MUST/SHOULD checklist as a separate comment.

Thanks.

Fixed stuff:

Spec URL: http://overholt.ca/eclipse/eclipse-emf.spec
SRPM URL: http://overholt.ca/eclipse/eclipse-emf-2.2.1-1.src.rpm
Comment 4 Thomas Fitzsimmons 2006-10-26 10:02:59 EDT
I'm seeing this error:

+ aot-compile-rpm --exclude
'/usr/share/eclipse/plugins/org.eclipse.emf.doc_*/doc.zip'
aot-compile-rpm: error:
/var/tmp/eclipse-emf-2.2.1-1-root-fitzsim/usr/share/eclipse/plugins/org.eclipse.emf.doc_*/doc.zip:
path does not exist or is not a job
error: Bad exit status from /var/tmp/rpm-tmp.11823 (%install)


RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.11823 (%install)
Comment 5 Andrew Overholt 2006-10-26 10:54:35 EDT
(In reply to comment #4)
> I'm seeing this error:
> 
> + aot-compile-rpm --exclude
> '/usr/share/eclipse/plugins/org.eclipse.emf.doc_*/doc.zip'
> aot-compile-rpm: error:
>
/var/tmp/eclipse-emf-2.2.1-1-root-fitzsim/usr/share/eclipse/plugins/org.eclipse.emf.doc_*/doc.zip:
> path does not exist or is not a job

Yeah, I fixed that and I *finally* got my mock setup working again (down
mirrors).  I've got a build going now that I think fixes that and one other
error.  I'll re-post when it finishes in mock.
Comment 6 Andrew Overholt 2006-10-26 14:12:00 EDT
(In reply to comment #5)
> Yeah, I fixed that and I *finally* got my mock setup working again (down
> mirrors).  I've got a build going now that I think fixes that and one other
> error.  I'll re-post when it finishes in mock.

Okay, I think this one will work:

Spec URL: http://overholt.ca/eclipse/eclipse-emf.spec
SRPM URL: http://overholt.ca/eclipse/eclipse-emf-2.2.1-1.src.rpm

It built in mock with --no-clean (I didn't want to wait for an entire run) and
the regular run is going now.  I anticipate no problems with that.
Comment 7 Andrew Overholt 2006-10-26 15:04:35 EDT
(In reply to comment #6) 
> It built in mock with --no-clean (I didn't want to wait for an entire run) and
> the regular run is going now.  I anticipate no problems with that.

It completed without problems in a regular mock run.
Comment 8 Thomas Fitzsimmons 2006-10-28 17:49:16 EDT
- MUST: rpmlint must be run on every package. The output should be posted in the
review.

$ rpmlint /home/fitzsim/rpmbuild/SRPMS/eclipse-emf-2.2.1-1.src.rpm
W: eclipse-emf strange-permission fetch-eclipse-emf.sh 0744

You should fix this warning.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-sdk-2.2.1-1.i386.rpm
W: eclipse-emf-sdk no-documentation

OK, since documentation is in main package.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-sdo-2.2.1-1.i386.rpm
W: eclipse-emf-sdo no-documentation

OK.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-xsd-2.2.1-1.i386.rpm
W: eclipse-emf-xsd no-documentation

OK.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-xsd-sdk-2.2.1-1.i386.rpm
W: eclipse-emf-xsd-sdk no-documentation

OK.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-examples-2.2.1-1.i386.rpm

OK.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-standalone-2.2.1-1.i386.rpm
E: eclipse-emf-standalone devel-dependency java-devel

rpmlint should special-case java-devel since it's not a -devel package in the
Fedora sense.  So this one is OK.

$ rpmlint /home/fitzsim/rpmbuild/RPMS/i386/eclipse-emf-debuginfo-2.2.1-1.i386.rpm

OK.

- MUST: The package must be named according to the Package Naming Guidelines.

OK.

- MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec

OK.

- MUST: The package must meet the Packaging Guidelines.

OK.

- MUST: The package must be licensed with an open-source compatible license and
meet other legal requirements as defined in the legal section of Packaging
Guidelines.

OK.

- MUST: The License field in the package spec file must match the actual license.

OK.

- MUST: If (and only if) the source package includes the text of the license(s)
in its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.

OK.

- MUST: The spec file must be written in American English.

OK.

- MUST: The spec file for the package MUST be legible. If the reviewer is unable
to read the spec file, it will be impossible to perform a review. Fedora is not
the place for entries into the Obfuscated Code Contest ([WWW]
http://www.ioccc.org/).

OK.

- MUST: The sources used to build the package must match the upstream source, as
provided in the spec URL. Reviewers should use md5sum for this task.

A reproducible snapshot is fine.

- MUST: The package must successfully compile and build into binary rpms on at
least one supported architecture.

OK.

- MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch needs to have a bug filed
in bugzilla, describing the reason that the package does not compile/build/work
on that architecture. The bug number should then be placed in a comment, next to
the corresponding ExcludeArch line. New packages will not have bugzilla entries
during the review process, so they should put this description in the comment
until the package is approved, then file the bugzilla entry, and replace the
long explanation with the bug number. (Extras Only) The bug should be marked as
blocking one (or more) of the following bugs to simplify tracking such issues:
[WWW] FE-ExcludeArch-x86, [WWW] FE-ExcludeArch-x64, [WWW] FE-ExcludeArch-ppc

OK.

- MUST: All build dependencies must be listed in BuildRequires, except for any
that are listed in the exceptions section of Packaging Guidelines; inclusion of
those as BuildRequires is optional. Apply common sense.

OK.

- MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

No locale data, so OK.

- MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun. If the package has multiple subpackages with libraries, each
subpackage should also have a %post/%postun section that calls /sbin/ldconfig.
An example of the correct syntax for this is:

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

No default path libraries, so OK.

- MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.

Not relocatable, so OK.

- MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. The exception to this are directories listed explicitly
in the Filesystem Hierarchy Standard ([WWW]
http://www.pathname.com/fhs/pub/fhs-2.3.html), as it is safe to assume that
those directories exist.

OK.

- MUST: A package must not contain any duplicate files in the %files listing.

OK.

- MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.

OK.

- MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).

OK.

- MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines.

OK.

- MUST: The package must contain code, or permissable content. This is described
in detail in the code vs. content section of Packaging Guidelines.

OK.

- MUST: Large documentation files should go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity)

OK.

- MUST: If a package includes something as %doc, it must not affect the runtime
of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.

OK.

- MUST: Header files or static libraries must be in a -devel package.

OK.

- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
directory ownership and usability).

OK.

- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel package.

OK.

- MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} 

OK.

- MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.

OK.

- MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section. This is described in detail in the desktop files section of
Packaging Guidelines. If you feel that your packaged GUI application does not
need a .desktop file, you must put a comment in the spec file with your explanation.

OK.

- MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another package
owns, then please present that at package review time.

OK.

- SHOULD: If the source package does not include license text(s) as a separate
file from upstream, the packager SHOULD query upstream to include it.

OK.

- SHOULD: The description and summary sections in the package spec file should
contain translations for supported Non-English languages, if available.

OK.

- SHOULD: The reviewer should test that the package builds in mock.

OK.

- SHOULD: The package should compile and build into binary rpms on all supported
architectures.

I only checked i386 but the build system will check the others.

- SHOULD: The reviewer should test that the package functions as described. A
package should not segfault instead of running, for example.

I was able to generate some code, following this tutorial:

http://www.eclipse.org/articles/Article-Using%20EMF/using-emf.html

- SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague,
and left up to the reviewers judgement to determine sanity.

You should probably use:

if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi

instead of:

%post sdo -p %{_bindir}/rebuild-gcj-db

to protect against the case where rebuild-gcj-db has been removed.

- SHOULD: Usually, subpackages other than devel should require the base package
using a fully versioned dependency.

standalone sub-package doesn't but that's intentional.

- SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and
this is usually for development purposes, so should be placed in a -devel pkg. A
reasonable exception is that the main pkg itself is a devel tool not installed
in a user runtime, e.g. gcc or gdb.

OK.

I'm assuming that you'll fix those remaining two issues, and changing the status
of this request to FE-ACCEPT.
Comment 9 Andrew Overholt 2006-10-29 18:23:34 EST
Thanks!

I've made the two changes and put an updated spec and srpm at the above URLs. 
The import script is somehow not working so I've put a note on the
CVSSyncRequest page.
Comment 10 Andrew Overholt 2006-10-30 13:41:43 EST
It's now imported and the build failed in devel.  The typo in the latest Eclipse
SDK packages (in core) has been fixed and once that's in rawhide, I'll rebuild.
 I've requested an FC-6 branch.
Comment 11 Kevin Fenzi 2006-12-05 22:23:48 EST
Hey Andrew... any news on getting this built? 

I see that it hasn't been added to the owners.list... can you do that please?
See:
http://fedoraproject.org/wiki/Extras/Contributors#head-f6f080b4c48fe519c98a29364a740953f90179e7

(Without that step, there is no bugzilla component for the package and people
can't report bugs... )
Comment 12 Andrew Overholt 2006-12-05 23:45:56 EST
I've got a build going now.  When that finishes, I'll add to the owners list. 
Sorry for the delay - I was working on the Eclipse SDK update a bit and wanted
that to get out first.
Comment 13 Andrew Overholt 2006-12-06 17:43:14 EST
Okay, the builds in both FC-6 and devel are finished and I've committed owners.
 Changing to CURRENTRELEASE.

Note You need to log in before you can comment on or make changes to this bug.